// This file comes with NO WARRANY and NO SUPPORT. You use it
// at your own risk.
// This is a Scilab files used to compute the examples of the paper
// "Une mthode d'identification
//  pour un systme linaire  retards"
// "A method of identification for a linear delays system".
// AUTHORS:
// Franois Ollivier
// ALIEN, INRIA-Futurs & LIX, E'cole Polytechnique
// F-91128 Palaiseau CEDEX FRANCE
// francois.ollivier@lix.polytechnique.fr
// Sad Moutaouakil
// Brahim Sadik
// Dpartement de Mathmatiques 
// Facult des Sciences Semlalia B.P. 2390,
// Avenue Safi, Marrakech, Maroc
// s.moutaouakil@ucam.ac.ma   sadik@ucam.ac.ma
////////////////////////////////////////////////////////////////////
// A detailed version of the paper may be found at url
// http://www.lix.polytechnique.fr/~ollivier/indexEngl.html
////////////////////////////////////////////////////////////////////
// This file has been used with scilab 3.0
// Scilab is available at url http://www.scilab.org/
////////////////////////////////////////////////////////////////////
// This file is used by the file example3.sci
////////////////////////////////////////////////////////////////////

function inte=intDiscr(Freq,A,B,T0,nn)
  n0=floor(T0*Freq);
  n1=n0+nn-1
  C=A(n0:n1).*B(1:n1-n0+1);
  inte=pas*((C(1)+C(n1-n0+1))/2+C(1,1:n1-n0)*ones(n1-n0,1));
endfunction;

//////////////////////////////////////////////////////////////////
//XX: output X
//UU: input U
//Freq: frequency of sampling
//T00: lower bound of the first interval of integration
// WARNING: T00 MUST BE GREATER THAN THE EXPECTED DELAYS R1 AND R2 !
//DT: shift between two intervals
//T: length of an interval
//m: number of intervals
// WARNING T00 + T + m*DT must be less than min(size(XX), size(UU))/Freq
// R10 and R20: initial (expected?) values for R1 and R2
// iter: number of iterations
//////////////////////////////////////////////////////////////////
function resu=twoDelaysIdentification(XX,UU,Freq,T00,DT,T,m,R10,R20,iter)
  RR1=R10;RR2=R20;
    for i=1:iter do
    CC=zeros(m,5);DD=zeros(m,1);
    omega=2*%pi/T;
    SIN=sin(omega*[0:pas:T]);
    COS=cos(omega*[0:pas:T]);[w,z]=size(COS);
    UNMOINSCOS=ones(w,z)-COS;
      for i=1:m do
        T0=T00+(i-1)*DT;
        DD(i,1)=omega^2*intDiscr(Freq,XX,COS,T0,z);
        CC(i,1)=-intDiscr(Freq,XX,UNMOINSCOS,T0-RR1,z);
        CC(i,2)=-intDiscr(Freq,XX,SIN,T0-RR1,z);
        CC(i,3)=intDiscr(Freq,UU,UNMOINSCOS,T0-RR2,z);
        CC(i,4)=intDiscr(Freq,UU,SIN,T0-RR2,z);
      end;
    re=lsq(CC,DD);
//asin should be used instead in theory, but this choice is better for convergence when R1 is great.
    RRR1=atan(re(2,1)/re(1,1));
    RR1=RR1+RRR1/omega;
    aa=re(1,1);
//asin should be used instead in theory, but this choice is better for convergence when R2 is great.
    RRR2=asin(re(4,1)/re(3,1));
    RR2=RR2+RRR2/omega;
    bb=re(3,1);
  end;
  resu=[aa, bb, RR1, RR2];
endfunction;

